//-----------------------------------------------------------------------
// This macro requires one parameter:  ...find-string...
//
// The "find-string" is specified in the same manner as that of Edit
// primary command FIND.
//
// THIS MACRO DELETES ALL LINES THAT CONTAIN THE FIND STRING.
//
// After the operation is complete, the file is positioned to the top.
// An information message is issued indicating action taken by the macro.
//-----------------------------------------------------------------------
void delall(int argc, char *argv[]) {

  char *command;
  int   find_line_count;

  if (argc == 2) {
    spfservice("cmd","x all");                 // exclude all lines
    command = strcompose("find all ",argv[1]); // synthesize FIND command with PARM1
    spfservice("cmd",command);                 // find lines containing target string
    find_line_count = spfservice("query","find_line_count"); // retrieve number of lines found
    if (find_line_count > 0) {                 // any lines found?
      spfservice("cmd","del all nx");          // delete found lines
    }
    spfservice("cmd","reset");                 // make remaining lines visible
    spfservice("cmd","top");                   // position file to top
    spfservice("cmd","cursor");                // leave cursor in primary command field
    // issue info message
    if (find_line_count > 0) {                 // any lines found?
      Msg(strcompose("DELALL deleted ",find_line_count," lines containing string:  ",argv[1]));
      }
    else {
      Msg(strcompose("DELALL did not find any lines containing string:  ",argv[1]));
    }
    }
  else {
    Msg("DELALL macro requires one parameter:  ...find-string...");
  }

} // delall
